<template>
  <div :key="filterKey" class="flex gap-2">
    <div class="flex items-center flex-wrap gap-2 flex-1">
      <svn-filter-item-chip
        v-for="item in filterItems"
        :key="item"
        :title="item?.title"
        :type="item?.type"
        :operator-options="item?.operatorOptions"
        :items="item.items"
        @update-selected-data-filters="updateSelectedDataFilters(item, $event)"
        @set-data-after-search="emit('set-data-after-search', item, $event)"
        @load-more-data="emit('load-more-data', item)"
      />

      <slot name="additional-filters"> </slot>
    </div>

    <v-btn
      v-if="showClearButton || getActiveFiltersCount()"
      variant="text"
      :text="'Clear all'"
      color="primary"
      class="!normal-case !text-xs !font-medium"
      @click="clearSelectedFilters"
    />
  </div>
</template>

<script setup>
import { ref } from 'vue';
import SvnFilterItemChip from '../../components/filters/SvnProFilterItemChip.vue';

const props = defineProps({
  filterItems: { type: Array, default: () => [] },
  showClearButton: { type: Boolean, default: false },
});
const selectedFilters = ref([]);
const filterKey = ref(0);

const emit = defineEmits([
  'update-selected-data-filters',
  'set-data-after-search',
  'load-more-data',
  'clear-filter',
]);

const getActiveFiltersCount = () => {
  return selectedFilters?.value?.length;
};

const clearSelectedFilters = () => {
  // Reset the `selectedFilters` to an empty array, clearing any currently selected filters.
  selectedFilters.value = [];

  // Loop through the list of filters provided via props and reset their values to null.
  for (let filter of props.filterItems) {
    filter.value = null; // Assumes each filter object has a `value` property to track its state.
  }

  // Increment the `filterKey` to trigger reactivity or a refresh mechanism in the UI.
  filterKey.value += 1;

  // Emit an event to notify the parent or other components that the selected filters have been cleared.
  // Pass an empty array as the updated selected filters data.
  emit('update-selected-data-filters', []);
  emit('clear-filter');
};

const updateSelectedDataFilters = (item, event) => {
  const name = item.alias ? item.alias : item.name;

  // Find the filter definition from the provided filter items based on the name.
  let found = props.filterItems?.find(
    (el) => (el.alias ? el.alias : el.name) === name
  );

  // Check if the filter is already present in the selected filters.
  let selectedObject = selectedFilters.value.find(
    (el) => (el.alias ? el.alias : el.name) === name
  );

  // Case 1: A new filter is being added (value exists, and it's not already selected).
  if (event.value?.length && found && !selectedObject) {
    // Update the filter with the new value and operator.
    found.value = event.value;
    found.operator = event.operator;
    // Add the filter to the selected filters list.
    selectedFilters.value.push(found);

    // Case 2: An existing filter is being updated (value exists, and it's already selected).
  } else if (event.value?.length && found && selectedObject) {
    // Update the value and operator for the existing filter in the selected list.
    selectedFilters.value.forEach((element) => {
      if ((element.alias ? element.alias : element.name) === name) {
        element.value = event.value;
        element.operator = event.operator;
      }
    });

    // Case 3: The filter is being cleared (value is empty or invalid).
  } else {
    // Remove the filter from the selected filters list.
    selectedFilters.value = selectedFilters.value.filter(
      (el) => (el.alias ? el.alias : el.name) !== name
    );
  }
  // Emit an event to notify parent components of the updated selected filters list.
  emit('update-selected-data-filters', selectedFilters.value);
};
</script>
